﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using EventPhone001.ServiceReference1;

namespace EventPhone001
{
    public partial class DetailsPage : PhoneApplicationPage
    {
        public Service1Client _sc;
        string fname;
        string lname;

        // Constructor
        public DetailsPage()
        {
            InitializeComponent();
            _sc = new Service1Client();
            _sc.ToggleRegisterCompleted += new EventHandler<System.ComponentModel.AsyncCompletedEventArgs>(_sc_ToggleRegisterCompleted);
            _sc.CheckInCompleted +=new EventHandler<CheckInCompletedEventArgs>(_sc_CheckInCompleted);
        }

        // When page is navigated to set data context to selected item in list
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            string selectedIndex = "";
            if (NavigationContext.QueryString.TryGetValue("selectedItem", out selectedIndex))
            {
                int index = int.Parse(selectedIndex);
                DataContext = App.ViewModel.Items[index];
            }
        }

        private void ContentText_Tap(object sender, GestureEventArgs e)
        {

        }

        private void ContentText_DoubleTap(object sender, GestureEventArgs e)
        {
            
        }

        public void _sc_ToggleRegisterCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            _sc.CheckInAsync(lname,fname);
            //MessageBox.Show("Checkin Status Changed");
            
        }

        public SolidColorBrush BrushFromColorName(string colorName)
        {
            string s;
            s = "<SolidColorBrush xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'";
            s += " Color='" + colorName + "'/>";

            return System.Windows.Markup.XamlReader.Load(s) as SolidColorBrush;
        }  


        public void _sc_CheckInCompleted(object sender, CheckInCompletedEventArgs e)
        {
            
            if ( e.Result.ToString() == "True")
            {                
                ListTitle.Foreground = BrushFromColorName("Green");
                MessageBox.Show("Checked IN");
            }
            else
            {
                ListTitle.Foreground = BrushFromColorName("Red"); 
                MessageBox.Show("Checked OUT");
            }

        }

        private void ListTitle_DoubleTap(object sender, GestureEventArgs e)
        {
            checkmein();
        }

        private void ApplicationBarMenuItem_Click(object sender, EventArgs e)
        {
            checkmein();
        }

        private void ApplicationBarIconButton_Click(object sender, EventArgs e)
        {
            checkmein();
        }

        private void checkmein()
        {
            string ss = ListTitle.Text;
            lname = ss.Substring(0, ss.IndexOf(','));
            fname = ss.Substring(lname.Length + 2).TrimEnd();
            _sc.ToggleRegisterAsync(lname, fname);  
        }

        private void ApplicationBarIconButton_Click_1(object sender, EventArgs e)
        {
            //NavigationService.Navigate(new Uri("http://www.facebook.com/groups/405426816152189/", UriKind.Absolute));
            NavigationService.Navigate(new Uri("/Facebook.xaml", UriKind.Relative));
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {           
            //button1.IconUri = new Uri("/Images/YourImage.png", UriKind.Relative);
        }

    
    }
}